﻿using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;

namespace TestProject
{
    /// <summary>
    /// 테스트 컨텍스트 메뉴
    /// </summary>
    public class TestContextMenu : ContextMenu
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 메뉴 항목 클릭 이벤트 - MenuItemClickEvent

        /// <summary>
        /// 메뉴 항목 클릭 이벤트
        /// </summary>
        public static readonly RoutedEvent MenuItemClickEvent = EventManager.RegisterRoutedEvent
        (
            "MenuItemClickEvent",
            RoutingStrategy.Bubble,
            typeof(RoutedEventArgs),
            typeof(TestContextMenu)
        );

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - TestContextMenu()

        /// <summary>
        /// 생성자
        /// </summary>
        public TestContextMenu()
        {
            AddHandler(MenuItem.ClickEvent, new RoutedEventHandler(MenuItem_Click));
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 메뉴 항목 클릭시 처리하기 - MenuItem_Click(sender, e)

        /// <summary>
        /// 메뉴 항목 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void MenuItem_Click(object sender, RoutedEventArgs e)
        {
            Popup popup = Parent as Popup;

            if(popup != null)
            {
                FrameworkElement targetElement = popup.PlacementTarget as FrameworkElement;

                if(targetElement != null)
                {
                    targetElement.RaiseEvent(new RoutedEventArgs(TestContextMenu.MenuItemClickEvent, e.Source));
                }
            }
        }

        #endregion
    }
}